# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# Versions of Cwd < 3 mostly work so don't bother about the version
%global old_cwd %(perl -MCwd -e 'print (($Cwd::VERSION < 3) ? 1 : 0);' 2>/dev/null || echo 0)

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.30) ? 1 : 0);' 2>/dev/null || echo 0)

# TODO: BR: perl(Test::Pod::LinkCheck) when available

Name:		perl-DateTime-TimeZone
Version:	1.65
Release:	1.0.cf.%{__distinit}%{__distvers}
Summary:	Time zone object base class and factory
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/DateTime/
Source0:	http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/DateTime-TimeZone-%{version}.tar.gz
Patch0:		DateTime-TimeZone-1.59-old-EU::MM.patch
Patch1:		DateTime-TimeZone-1.64-old-Cwd.patch
Patch3:		DateTime-TimeZone-1.64-old-Test::More.patch
Patch4:		DateTime-TimeZone-1.35-5.8.8.patch
Patch5:		DateTime-TimeZone-1.59-spelling.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(base)
BuildRequires:	perl(Class::Load)
BuildRequires:	perl(Class::Singleton) >= 1.03
BuildRequires:	perl(constant)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
BuildRequires:	perl(List::Util)
BuildRequires:	perl(Params::Validate) >= 0.72
BuildRequires:	perl(parent)
BuildRequires:	perl(Pod::Man) >= 1.14
BuildRequires:	perl(Storable)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::Fatal)
BuildRequires:	perl(Test::More) >= 0.34
BuildRequires:	perl(Test::Output)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.04
# No Test::Requires prior to Perl 5.8.8 (FC-5)
%if %(perl -e 'print $] >= 5.008008 ? 1 : 0;')
BuildRequires:	perl(Test::Requires)
%endif
BuildRequires:	perl(Test::Taint)
# DateTime used in test suite, but it wants DateTime::TimeZone for its own test suite
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(DateTime)
BuildRequires:	perl(DateTime::Duration)
# Test::Spelling -> Pod::Spell -> File::ShareDir::ProjectDistDir -> Path::IsDev ->
#   Role::Tiny -> namespace::autoclean -> Moose -> DateTime::Calendar::Mayan -> DateTime::TimeZone
BuildRequires:	perl(Test::Spelling), aspell-en
%endif
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Class::Singleton) >= 1.03

# Don't require Win32 modules (rpm ≥ 4.9)
%global __requires_exclude ^perl\\(Win32

%description
This class is the base class for all time zone objects. A time zone is
represented internally as a set of observances, each of which describes the
offset from GMT for a given time period.

Note that without the DateTime.pm module, this module does not do much. Its
primary interface is through a DateTime object, and most users will not need
to directly use DateTime::TimeZone methods.

%prep
%setup -q -n DateTime-TimeZone-%{version}

# Don't need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch0
%endif

# Can get away with Cwd < 3
%if %{old_cwd}
%patch1
%endif

# Test suite uses feature from Test::More 0.88
%if %{old_test_more}
%patch3 -p1
%endif

# DateTime::TimeZone test 04local.t tickles a Test::Builder bug in 5.8.8
%patch4 -p2

# Add extra stopwords to spellchecker test
%patch5

# Remove unwanted Win32 dependencies (rpm < 4.9)
%global reqfilt /bin/sh -c "%{__perl_requires} | grep -v '^perl(Win32'"
%define __perl_requires %{reqfilt}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test RELEASE_TESTING=1

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes LICENSE README
%{perl_vendorlib}/DateTime/
%{_mandir}/man3/DateTime::TimeZone.3pm*
%{_mandir}/man3/DateTime::TimeZone::Catalog.3pm*
%{_mandir}/man3/DateTime::TimeZone::Floating.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local::Unix.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local::VMS.3pm*
%{_mandir}/man3/DateTime::TimeZone::Local::Win32.3pm*
%{_mandir}/man3/DateTime::TimeZone::OffsetOnly.3pm*
%{_mandir}/man3/DateTime::TimeZone::OlsonDB.3pm*
%{_mandir}/man3/DateTime::TimeZone::UTC.3pm*

%changelog
* Mon Mar 10 2014 Paul Howarth <paul@city-fan.org> - 1.65-1.0.cf
- Update to 1.65
  - This release is based on version 2014a of the Olson database
  - Contemporary changes for Turkey

* Sat Feb  8 2014 Paul Howarth <paul@city-fan.org> - 1.64-1.0.cf
- Update to 1.64
  - Under taint mode, DateTime::TimeZone->new( name => 'local' ) could die
    depending on the method used to find the local time zone name, and the
    resulting variable would often be tainted; we now untaint all names
    before attempting to load them (CPAN RT#92631)
- Update patches as needed

* Thu Jan 16 2014 Paul Howarth <paul@city-fan.org> - 1.63-2.0.cf
- Don't BR: perl(Test::Spelling) when bootstrapping

* Mon Oct 28 2013 Paul Howarth <paul@city-fan.org> - 1.63-1.0.cf
- Update to 1.63
  - This release is based on version 2013h of the Olson database
  - Contemporary changes for Morocco, Libya, and Western Sahara (El Aaiun)

* Thu Sep 26 2013 Paul Howarth <paul@city-fan.org> - 1.62-1.0.cf
- Update to 1.62
  - This release is based on version 2013f of the Olson database
  - Contemporary changes for Tocantins, Jordan, and Palestine

* Sat Sep 21 2013 Paul Howarth <paul@city-fan.org> - 1.61-1.0.cf
- Update to 1.61
  - This release is based on version 2013e of the Olson database
  - Contemporary changes for Fiji, Indonesia and San Luis, Argentina
  - Also a number of historical changes
  - See http://mm.icann.org/pipermail/tz-announce/2013-September/000013.html
    for more details

* Wed Jul 24 2013 Paul Howarth <paul@city-fan.org> - 1.60-2.0.cf
- Perl 5.18 rebuild

* Mon Jul  8 2013 Paul Howarth <paul@city-fan.org> - 1.60-1.0.cf
- Update to 1.60
  - This release is based on version 2013d of the Olson database
  - Contemporary changes for Morocco and Israel
  - Historical changes for Jerusalem
- Update old-Cwd patch to avoid inclusion of .orig file in built package

* Sat Apr 20 2013 Paul Howarth <paul@city-fan.org> - 1.59-1.0.cf
- Update to 1.59:
  - This release is based on version 2013c of the Olson database
  - Contemporary changes for Palestine and Paraguay
  - Also a number of historical changes
- Update patches as necessary

* Tue Mar 12 2013 Paul Howarth <paul@city-fan.org> - 1.58-1.0.cf
- Update to 1.58:
  - This release is based on version 2013b of the Olson database
  - Contemporary changes for Haiti, Paraguay, and Morocco
  - See http://mm.icann.org/pipermail/tz-announce/2013-March/000010.html for
    more details

* Sun Mar  3 2013 Paul Howarth <paul@city-fan.org> - 1.57-1.0.cf
- Update to 1.57:
  - This release is based on version 2013a of the Olson database
  - Contemporary changes for Chile as well as several new zones: Asia/Khandyga,
    Asia/Ust-Nera, and Europe/Busingen
  - Also a number of historical changes
- Update POD spelling patch to account for Test::Spelling seeming to be more
  fussy about case than before

* Sat Dec  1 2012 Paul Howarth <paul@city-fan.org> - 1.56-1.0.cf
- Update to 1.56:
  - Updated mapping from Win32 to Olson time zone names (CPAN RT#81456)

* Tue Nov 13 2012 Paul Howarth <paul@city-fan.org> - 1.54-1.0.cf
- Update to 1.54:
  - This release is based on version 2012j of the Olson database
  - Contemporary changes for Libya

* Sun Nov  4 2012 Paul Howarth <paul@city-fan.org> - 1.53-1.0.cf
- Update to 1.53:
  - This release is based on version 2012i of the Olson database
  - Contemporary changes for Cuba

* Wed Oct 31 2012 Paul Howarth <paul@city-fan.org> - 1.52-1.0.cf
- Update to 1.52:
  - This release is based on version 2012h of the Olson database
  - Contemporary changes for Brazil, Israel, and Jordan
- NoTabs test dropped upstream, so drop BR: perl(Test::NoTabs)
- Update spelling patch

* Thu Oct 18 2012 Paul Howarth <paul@city-fan.org> - 1.51-1.0.cf
- Update to 1.51:
  - This release is based on version 2012g of the Olson database
  - Contemporary changes for Palestine and Samoa

* Mon Sep 17 2012 Paul Howarth <paul@city-fan.org> - 1.50-1.0.cf
- Update to 1.50:
  - In scalar context, DateTime::TimeZone->names_in_category returned an
    arrayref containing an arrayref, rather than _just_ an arrayref
    (CPAN RT#76791)
  - The DateTime::TimeZone->names_in_category documentation claimed that it
    returned names based on the population of the zone, which is not true
    (CPAN RT#76792); note though that the DateTime::TimeZone->names_in_country
    method does preserve the order specified in the Olson database, which is
    sort of based on population and geography and is probably the best choice
    for presenting a list of names to end user
- Update patch for building with old Test::More versions

* Thu Sep 13 2012 Paul Howarth <paul@city-fan.org> - 1.49-1.0.cf
- Update to 1.49:
  - This release is based on version 2012f of the Olson database
  - Contemporary changes for Fiji

* Fri Aug  3 2012 Paul Howarth <paul@city-fan.org> - 1.48-1.0.cf
- Update to 1.48:
  - This release is based on version 2012e of the Olson database
  - Contemporary changes for Fakaofo

* Fri Jul 20 2012 Paul Howarth <paul@city-fan.org> - 1.47-1.0.cf
- Update to 1.47:
  - This release is based on version 2012d of the Olson database
  - Contemporary changes for Morocco

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 1.46-3.0.cf
- Perl 5.16 post-bootstrap rebuild

* Thu Jul 12 2012 Paul Howarth <paul@city-fan.org> - 1.46-2.0.cf
- BR: perl(base), perl(constant), perl(File::Spec), perl(lib),
  perl(List::Util) and perl(Storable)
- BR: perl(DateTime::Duration) unless we're bootstrapping

* Mon Apr  2 2012 Paul Howarth <paul@city-fan.org> - 1.46-1.0.cf
- Update to 1.46:
  - This release is based on version 2012c of the Olson database
  - Contemporary changes for Morocco, Palestine, Syria, and Haiti

* Sat Mar  3 2012 Paul Howarth <paul@city-fan.org> - 1.45-1.0.cf
- Update to 1.45:
  - Remove the dependency on DateTime and DateTime::Duration that was
    accidentally added in 1.43 (CPAN RT#75508)

* Fri Mar  2 2012 Paul Howarth <paul@city-fan.org> - 1.44-1.0.cf
- Update to 1.44:
  - This release is based on version 2012b of the Olson database
  - Contemporary changes for Cuba
- Don't need to remove empty directories from buildroot
- Drop support for distributions prior to FC-3:
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Don't need to define %%{perl_vendorlib}
  - Never need to BR: aspell-en-gb

* Thu Mar  1 2012 Paul Howarth <paul@city-fan.org> - 1.43-1.0.cf
- Update to 1.43:
  - This release is based on version 2012a of the Olson database
  - Contemporary changes for Armenia, Chile, the Falkland Islands, and Tokelau
- BR: perl(Cwd)
- BR: at least version 0.72 of perl(Params::Validate)
- Add patch to support building with Cwd < 3
- Update patch for old Test::More versions

* Mon Nov  7 2011 Paul Howarth <paul@city-fan.org> - 1.42-1.0.cf
- Update to 1.42:
  - This release is based on version 2011n of the Olson database
  - Contemporary changes for Fiji, Moldova (reversing the 2011m changes), and
    Cuba; the Moldova change removes the Europe/Tiraspol zone added in the
    previous release

* Mon Oct 24 2011 Paul Howarth <paul@city-fan.org> - 1.41-1.0.cf
- Update to 1.41:
  - This release is based on version 2011m of the Olson database
  - Contemporary changes for Brazil, Moldova, and Ukraine

* Mon Oct 10 2011 Paul Howarth <paul@city-fan.org> - 1.40-1.0.cf
- Update to 1.40:
  - This release is based on version 2011l of the Olson database
  - Contemporary changes for Palestine, Fiji, Russia, Belarus, Ukraine, and
    several other post-Soviet states

* Mon Sep 26 2011 Paul Howarth <paul@city-fan.org> - 1.39-1.0.cf
- Update to 1.39:
  - This release is based on version 2011k of the Olson database
  - Contemporary changes for Palestine, Belarus and Ukraine

* Tue Sep 20 2011 Paul Howarth <paul@city-fan.org> - 1.38-1.0.cf
- Update to 1.38:
  - Removed code matching /^package/ in tools/parse_olson, which was confusing
    the metacpan indexer

* Tue Sep 13 2011 Paul Howarth <paul@city-fan.org> - 1.37-1.0.cf
- Update to 1.37:
  - This release is based on version 2011j of the Olson database
  - Contemporary changes for Samoa and historical changes for Kenya, Uganda
    and Tanzania

* Tue Sep  6 2011 Paul Howarth <paul@city-fan.org> - 1.36-1.0.cf
- Update to 1.36:
  - This release is based on version 2011i of the Olson database
  - New zone for South Sudan (Africa/Juba)
  - Changes for Samoa, Kaliningrad (Russia), Alaska, Hawaii,
    Newfoundland/Labrador (Canada) and Resolute Bay
- Update patch for building with old ExtUtils::MakeMaker versions

* Fri Aug 19 2011 Paul Howarth <paul@city-fan.org> - 1.35-3.1.cf
- Can now do a non-bootstrap build

* Fri Aug 19 2011 Paul Howarth <paul@city-fan.org> - 1.35-3.0.cf
- Unbundle from perl-DateTime
- First build is a bootstrap build without perl(DateTime) for testing
